Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1082)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1083)
@@ -906,263 +923,265 @@
          enddo
       enddo
-       IF (flag_tke(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tke",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_tke_max(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tke_max",itau_w,zx_tmp_fi3d)
+       IF (o_tke%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tke%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_tke_max%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_tke_max%name,itau_w,zx_tmp_fi3d)
        ENDIF
       endif
 
-       IF (flag_kz(iff)<=lev_files(iff)) THEN
-      ! combinaision de cdrag et le coef melange dans la meme variable
-      zx_tmp_fi3d(:,1)     = cdragh(:) 
-      zx_tmp_fi3d(:,2:klev)= coefh(:,2:klev)
-      CALL histwrite_phy(nid_files(iff),"kz",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_kz_max(iff)<=lev_files(iff)) THEN
-      ! combinaision de cdrag et le coef melange dans la meme variable
-      zx_tmp_fi3d(:,1)     = cdragh(:)
-      zx_tmp_fi3d(:,2:klev)= coefh(:,2:klev)
-      CALL histwrite_phy(nid_files(iff),"kz_max",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_clwcon(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"clwcon",itau_w,clwcon0)
+       IF (o_kz%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_kz%name,itau_w,coefh)
+       ENDIF
+
+       IF (o_kz_max%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_kz_max%name,itau_w,coefh)
+       ENDIF
+
+       IF (o_clwcon%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_clwcon%name,itau_w,clwcon0)
        ENDIF
 
       IF(iflag_con.GE.3) THEN
-       IF (flag_Ma(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"Ma",itau_w,Ma)
-       ENDIF
-
-       IF (flag_dnwd(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dnwd",itau_w,dnwd)
-       ENDIF
-
-       IF (flag_dnwd0(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dnwd0",itau_w,dnwd0)
+       IF (o_Ma%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_Ma%name,itau_w,Ma)
+       ENDIF
+
+       IF (o_dnwd%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dnwd%name,itau_w,dnwd)
+       ENDIF
+
+       IF (o_dnwd0%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dnwd0%name,itau_w,dnwd0)
        ENDIF
       ENDIF !(iflag_con.GE.3)
 
-       IF (flag_dtdyn(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dtdyn",itau_w,d_t_dyn)
-       ENDIF
-
-       IF (flag_dqdyn(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dqdyn",itau_w,d_q_dyn)
-       ENDIF
-
-       IF (flag_dudyn(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"dudyn",itau_w,d_u_dyn)
+       IF (o_dtdyn%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtdyn%name,itau_w,d_t_dyn)
+       ENDIF
+
+       IF (o_dqdyn%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dqdyn%name,itau_w,d_q_dyn)
+       ENDIF
+
+       IF (o_dudyn%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dudyn%name,itau_w,d_u_dyn)
        ENDIF                                                    
 
-       IF (flag_dvdyn(iff)<=lev_files(iff)) THEN                 
-      CALL histwrite_phy(nid_files(iff),"dvdyn",itau_w,d_v_dyn)  
+       IF (o_dvdyn%flag(iff)<=lev_files(iff)) THEN                 
+      CALL histwrite_phy(nid_files(iff),o_dvdyn%name,itau_w,d_v_dyn)  
        ENDIF                                                     
 
-       IF (flag_dtcon(iff)<=lev_files(iff)) THEN
+       IF (o_dtcon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dtcon",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_ducon(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtcon%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_ducon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_u_con(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"ducon",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dqcon(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ducon%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dqcon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dqcon",itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),o_dqcon%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
       IF(iflag_con.GE.3) THEN
        IF (iflag_wake == 1) THEN
-         IF (flag_dtwak(iff)<=lev_files(iff)) THEN
-           zx_tmp_fi3d(1:klon,1:klev)=d_t_wake(1:klon,1:klev)           &
+         IF (o_dtwak%flag(iff)<=lev_files(iff)) THEN
+           zx_tmp_fi3d(1:klon,1:klev)=d_t_wake(1:klon,1:klev)           
      &                                        /pdtphys
-           CALL histwrite_phy(nid_files(iff),"dtwak",itau_w,zx_tmp_fi3d)
+           CALL histwrite_phy(nid_files(iff),
+     &                       o_dtwak%name,itau_w,zx_tmp_fi3d)
          ENDIF
 
-        IF (flag_dqwak(iff)<=lev_files(iff)) THEN
+        IF (o_dqwak%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi3d(1:klon,1:klev)=d_q_wake(1:klon,1:klev)/pdtphys
-        CALL histwrite_phy(nid_files(iff),"dqwak",itau_w,zx_tmp_fi3d)
+        CALL histwrite_phy(nid_files(iff),
+     &                     o_dqwak%name,itau_w,zx_tmp_fi3d)
         ENDIF
        ENDIF
       ENDIF !(iflag_con.GE.3) 
 
-       IF (flag_dtlsc(iff)<=lev_files(iff)) THEN
+       IF (o_dtlsc%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_lsc(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dtlsc",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtlschr(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtlsc%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtlschr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon, 1:klev)=(d_t_lsc(1:klon,1:klev)+
      $                           d_t_eva(1:klon,1:klev))/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dtlschr",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dqlsc(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_dtlschr%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dqlsc%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_lsc(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dqlsc",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtvdf(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dqlsc%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dtvdf",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dqvdf(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtvdf%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dqvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dqvdf",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dteva(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dqvdf%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dteva%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_eva(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dteva",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dqeva(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dteva%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dqeva%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_eva(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dqeva",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_ptconv(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dqeva%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_ptconv%flag(iff)<=lev_files(iff)) THEN
       zpt_conv = 0.
       where (ptconv) zpt_conv = 1.
-      CALL histwrite_phy(nid_files(iff),"ptconv",itau_w,zpt_conv)
-       ENDIF
-
-       IF (flag_ratqs(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"ratqs",itau_w,ratqs)
-       ENDIF
-
-       IF (flag_dtthe(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ptconv%name,itau_w,zpt_conv)
+       ENDIF
+
+       IF (o_ratqs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ratqs%name,itau_w,ratqs)
+       ENDIF
+
+       IF (o_dtthe%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_ajs(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dtthe",itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),o_dtthe%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (iflag_thermals.gt.1) THEN
-        IF (flag_f_th(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"f_th",itau_w,fm_therm)
-        ENDIF
-
-        IF (flag_e_th(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"e_th",itau_w,entr_therm)
-        ENDIF
-
-        IF (flag_w_th(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"w_th",itau_w,zw2)
-        ENDIF
-
-        IF (flag_q_th(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"q_th",itau_w,zqasc)
-        ENDIF
-
-        IF (flag_lambda_th(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"lambda_th",itau_w,lambda_th)
-        ENDIF
-
-        IF (flag_a_th(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"a_th",itau_w,fraca)
-        ENDIF
-
-       IF (flag_d_th(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"d_th",itau_w,detr_therm)
+        IF (o_f_th%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),o_f_th%name,itau_w,fm_therm)
+        ENDIF
+
+        IF (o_e_th%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),o_e_th%name,itau_w,entr_therm)
+        ENDIF
+
+        IF (o_w_th%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),o_w_th%name,itau_w,zw2)
+        ENDIF
+
+        IF (o_q_th%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),o_q_th%name,itau_w,zqasc)
+        ENDIF
+
+        IF (o_lambda_th%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),
+     s                     o_lambda_th%name,itau_w,lambda_th)
+        ENDIF
+
+        IF (o_a_th%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),o_a_th%name,itau_w,fraca)
+        ENDIF
+
+       IF (o_d_th%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_d_th%name,itau_w,detr_therm)
        ENDIF
 
        ENDIF !iflag_thermals
 
-       IF (flag_f0_th(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"f0_th",itau_w,f0)
-       ENDIF
-
-       IF (flag_f0_th(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"zmax_th",itau_w,zmax0)
-       ENDIF
-
-       IF (flag_dqthe(iff)<=lev_files(iff)) THEN
+       IF (o_f0_th%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_f0_th%name,itau_w,f0)
+       ENDIF
+
+       IF (o_f0_th%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_zmax_th%name,itau_w,zmax0)
+       ENDIF
+
+       IF (o_dqthe%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_ajs(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dqthe",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtajs(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dqthe%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtajs%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_ajsb(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dtajs",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dqajs(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtajs%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dqajs%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_ajsb(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dqajs",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtswr(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dqajs%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtswr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),"dtswr",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtsw0(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtswr%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtsw0%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=heat0(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),"dtsw0",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtlwr(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtsw0%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtlwr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),"dtlwr",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtlw0(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtlwr%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtlw0%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=-1.*cool0(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),"dtlw0",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dtec(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtlw0%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dtec%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-      CALL histwrite_phy(nid_files(iff),"dtec",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_duvdf(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dtec%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_duvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_u_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"duvdf",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-       IF (flag_dvvdf(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_duvdf%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dvvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_v_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dvvdf",itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),o_dvvdf%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (ok_orodr) THEN
-      IF (flag_duoro(iff)<=lev_files(iff)) THEN 
+      IF (o_duoro%flag(iff)<=lev_files(iff)) THEN 
       zx_tmp_fi3d(1:klon,1:klev)=d_u_oro(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"duoro",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-      IF (flag_dvoro(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_duoro%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+      IF (o_dvoro%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_v_oro(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dvoro",itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),o_dvoro%name,itau_w,zx_tmp_fi3d)
       ENDIF
        ENDIF
 
         IF (ok_orolf) THEN
-       IF (flag_dulif(iff)<=lev_files(iff)) THEN
+       IF (o_dulif%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_u_lif(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dulif",itau_w,zx_tmp_fi3d)
-       ENDIF
-
-        IF (flag_dvlif(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dulif%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+        IF (o_dvlif%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_v_lif(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),"dvlif",itau_w,zx_tmp_fi3d)
-       ENDIF
-        ENDIF
-
-       IF (flag_trac(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_dvlif%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+        ENDIF
+
+!       IF (o_trac%flag(iff)<=lev_files(iff)) THEN
          if (nqmax.GE.3) THEN
-           DO iq=3,nqmax
-         CALL histwrite_phy(nid_files(iff),tnom(iq),itau_w,qx(:,:,iq))
+!           DO iq=3,nqmax
+           DO iq=3,4
+       IF (o_trac(iq-2)%flag(iff)<=lev_files(iff)) THEN
+         CALL histwrite_phy(nid_files(iff),
+     s                  o_trac(iq-2)%name,itau_w,qx(:,:,iq))
+       ENDIF
            ENDDO
-          endif
-
-       ENDIF
+         endif
+
       if (ok_sync) then
 c$OMP MASTER
